package adt2prism;

import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author zaas
 */
public class ADT2PRISM {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
       
        if (args.length == 0 || args[0] == null || args[0].equals("") )
            System.out.println( "Please invoke the program as\n\t java -jar ADT2PRISM.jar <path-to-tree>.xml");
        
        //String sFile = "/Users/zaas/Desktop/RFID.xml";
        //"/Users/zaas/Desktop/InfectComputer.xml"
   
        try {
            System.out.println("Parsing" + args[0] + " ... \n");
            ADNode tree = ADTreeParser.ParseTree(args[0]);
            System.out.println("Transforming to PRISM ... \n");
            //printing to file
            StringBuilder sbFile = tree.toPRISMGames();
       
            FileWriter fw = new FileWriter("output.prism", false);
            fw.write(sbFile.toString());
            fw.close();
                      
             System.out.println("PRISM code generated in output.prism" );
        } 
        catch (IOException ex) {
             System.out.println("Exception - Unable to write to file");
        }
        catch (Exception ex) {
            System.err.println("Exception - Unable to parse the input file");
        }
    }
    
    /*private static void printTable(Hashtable<String, ADNode[]> t) {
        
         Set<String> keys = t.keySet();
         
        for(String key: keys){
            System.out.print(key + " = ");
            ADNode[] values = t.get(key);
            for (int i = 0; i<values.length; i++) {
               System.out.print(values[i].getLabel() + "_"); 
            }
            System.out.print("\n");
        }
    }*/
}
